/**
 * Yet another Ivy java program example
 *
 * This is the example from the documentations, it connects to the bus, and
 * translate the messages beginning with "Hello" by the same message, where
 * "Hello" is replaced by "Bonjour".
 *
 * @author Yannick Jestin <jestin@cena.fr>
 *
 * (c) CENA
 *
 * This program is distributed as is, under the LGPL licence, which should be
 * present in the package.
 *
 */
import fr.dgac.ivy.* ;

class ivyTranslater implements IvyMessageListener {

    private Ivy bus;

    ivyTranslater() {
      bus = new Ivy("IvyTranslater","Hello le monde",null);
      bus.bindMsg("^Hello(.*)",this);
      bus.bindMsg("^Bye$",new IvyMessageListener() {
	// callback for "Bye" message
	public void receive(IvyClient client,
	  String[] args) {System.exit(0);}
      });
      try {
	// starts the bus on the default domain or IVY_DOMAIN property
	bus.start(null);
      } catch (IvyException ie) {
	System.err.println("can't run the Ivy bus" + ie.getMessage());
      }
    }

    // callback associated to the "Hello" messages"
    public void receive(IvyClient client, String[] args) {
      bus.sendMsg("Bonjour"+((args.length>0)?args[0]:""));
    }

    public static void main(String args[]) {
      new ivyTranslater();
    }
}
