/**
 * @author	Yannick Jestin
 * @author	<a href="http://www.tls.cena.fr/products/ivy/">http://www.tls.cena.fr/products/ivy/</a>
 *
 *  CHANGELOG:
 *  1.2.4:
 */

package fr.dgac.ivy ;
import java.util.*;

class WaiterClient extends IvyApplicationAdapter implements Runnable {
    private static final int INCREMENT = 100;
    int timeout;
    private IvyClient received=null;
    private boolean forever=false;
    private Thread t;
    String name;

    WaiterClient(String n,int timeout) {
      this.timeout=timeout;
      name=n;
      if (timeout<=0) forever=true;
      t=new Thread(this);
    }

    IvyClient waitForClient() {
      t.start();
      try { t.join(); } catch (InterruptedException ie) { return null; }
      return received;
    }

    public void run() {
      boolean encore=true;
      // System.out.println("DEV WaiterClient start");
      while (encore) {
	try {
	  t.sleep(INCREMENT);
	  if (!forever) {
	    timeout-=INCREMENT;
	    if (timeout<=0) encore=false;
	  }
	} catch (InterruptedException ie) {
	  break;
	}
      }
      // System.out.println("DEV WaiterClient stop");
    }

    public void connect(fr.dgac.ivy.IvyClient client)  {
      if (name.compareTo(client.getApplicationName())!=0) return;
      received=client;
      t.interrupt();
    }
  }
